;Przykładowy program POOL, możesz go używać,
;modyfikować i rozpowszechniać na licencji GPL.
;Autorzy: R&D Independent Team
;Źródło: www.pool-rnd.com

to arrow :p :c :d
  ht
  "f := 0
  to force_a
    op array (0.01 * :f * :d,1) (0.01 * :f * :d,2)
  end

  let "l label "oOo :p
  let "pressed false
  let "start "false
  to start
    settext :l 0 "start := true
  end
  to onkeydown :code
    if :start && :code = :c ["pressed := true]
  end
  to onkeyup :code
    if :start && :code = :c ["pressed := false]
  end

  let "k 0
  let "fprev :f
  to onsignalarrows
    ifelse :pressed [
      if :f < 100 ["f += 1.5]
      if :f > 100 ["f := 100]
    ] [
      if :f > 0 ["f *= 0.9]
      if :f < 0 ["f := 0]
    ]
    if (:k % 3 = 0) && (:f <> :fprev) [
      settext :l int :f
      "fprev := :f
    ]
    "k += 1
  end
end

to bubble :r :mass [:loss 0.008]
  local [d w g]
  to force :xy
    :xy,1 -= xcor
    :xy,2 -= ycor
    "d := sqrt :xy,1^2 + :xy,2^2
    "w := (:d / :r)^2
    "g := 1.5 * (0.5 - (1.5 / exp :w^3)) / (-0.5 * (:w + 1) * :d)
    :xy,1 *= :g
    :xy,2 *= :g
    op :xy
  end

  to fdraw :x :y
    let "d2 (:x - xcor)^2 + (:y - ycor)^2
    let "c 100 * :d2 / :r^2
    if :c > 100 ["c := (100 - 75 * ((sqrt :d2) - :r))]
    if :c < 0 ["c := 0]
    op (array 0 0 10 :c)
  end

  to draw :a (render $fdraw :a :p0 :p1) end

  to sum_forces
    let "fa force_a @ :fs
    let "f newarray 2
    foreach "t :fb [
      if :t <> this [
        let "g force pos @ :t
        :f,1 += :g,1
        :f,2 += :g,2
      ]
    ]
    foreach "a :fa [
      :f,1 += :a,1
      :f,2 += :a,2
    ]
    output :f
  end

  let "speed 0
  to onsignalstep :turtle :data
    let "dt :data,2
    ifelse :dt < 80 ["dt := 0.01 * :dt] ["dt := 0.8]
    let "f sum_forces
    lock "speed [
      let "mdir movedir
      :mdir,1 := :mdir,1 * :speed + :f,1 * :dt / :mass
      :mdir,2 := :mdir,2 * :speed + :f,2 * :dt / :mass
      "speed := sqrt (:mdir,1)^2 + (:mdir,2)^2
      if :speed > 50 ["speed := 50]
      setmovedir :mdir alignh
      let "ds :speed * :dt
      "speed -= :loss * :ds
      if :speed < 0 ["speed := 0]
    ]
    fd :ds
  end

  ht
  let "p0 array (xcor - :r - 4) (ycor + :r + 4)
  let "p1 array (xcor + :r + 4) (ycor - :r - 4)
  draw 60
  let "img image :p0 :p1
  clean

  (setti :img :img 1)
  setr :r
end

ht pu bounce
shared [fs fb]
"fs := newarray 4
"fb := newarray 4

:fb,1 := (newt $bubble 30 1.6)
:fb,2 := (newt $bubble 40 1.8)
:fb,3 := (newt $bubble 50 2.0)
:fb,4 := (newt $bubble 65 2.2)

:fs,1 := (anewt $arrow [20 40 60 22] 37 {-1 0}) ;left
:fs,2 := (anewt $arrow [90 40 60 22] 39 {1 0})  ;right
:fs,3 := (anewt $arrow [55 12 60 22] 38 {0 1})  ;up
:fs,4 := (anewt $arrow [55 68 60 22] 40 {0 -1}) ;down

setbg {90 87 95}

foreach "i :fb [
  (setxy rnorm 100 rnorm 100) @ :i
  st @ :i
]
foreach "i :fs [start @ :i]

"u := timer "arrows 15
"t := timer "step 13


